---
title: "Step 8: Create a Workday writeback propagation rule"
component: pingone-api
page_id: pingone-api:workflow-library:platform-sso-and-authorization/identity-propagation/create-a-workday-propagation-connection/step-8-create-a-workday-writeback-propagation-rule
canonical_url: https://developer.pingidentity.com/pingone-api/workflow-library/platform-sso-and-authorization/identity-propagation/create-a-workday-propagation-connection/step-8-create-a-workday-writeback-propagation-rule.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Step 8: Create a Workday writeback propagation rule

##

 

```none
POST {{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules
```

Use `POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules` to add a Workday writeback propagation rule to the specified environment. Workday writeback propagation rules only operate on user records that have been provisioned inbound by the parent rule, the population expression filter, `populationExpression`, and the deprecated population id references, `population.id`, do not apply. Available user attributes for any store can be obtained with the appropriate request found in [Propagation Store Metadata](../../../../platform/identity-propagation-provisioning/propagation-store-metadata.html) and looking under `userAttributes`.

|   |                                                                                                                          |
| - | ------------------------------------------------------------------------------------------------------------------------ |
|   | While required for Workday, a writeback propagation rule is specific to Workday and not used for other connection types. |

> **Collapse: Request Model**
>
> | Property         | Type   | Required? |
> | ---------------- | ------ | --------- |
> | `description`    | String | Optional  |
> | `environment.id` | String | Required  |
> | `name`           | String | Required  |
> | `parentRule.id`  | String | Required  |
> | `plan.id`        | String | Required  |
> | `sourceStore.id` | String | Required  |
> | `targetStore.id` | String | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "plan": {
        "id": "{{wdPlanID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
        "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
        "id": "{{wdInboundRuleID}}"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "plan": {
        "id": "{{wdPlanID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
        "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
        "id": "{{wdInboundRuleID}}"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""plan"": {" + "\n" +
@"        ""id"": ""{{wdPlanID}}""" + "\n" +
@"    }," + "\n" +
@"    ""environment"": {" + "\n" +
@"        ""id"": ""{{envID}}""" + "\n" +
@"    }," + "\n" +
@"    ""sourceStore"": {" + "\n" +
@"        ""id"": ""{{wdWritebackStoreID}}""" + "\n" +
@"    }," + "\n" +
@"    ""targetStore"": {" + "\n" +
@"        ""id"": ""{{wdSourceStoreID}}""" + "\n" +
@"    }," + "\n" +
@"    ""name"": ""Workday Use Case Writeback Rule""," + "\n" +
@"    ""description"": ""Workday use case writeback rule description""," + "\n" +
@"    ""parentRule"": {" + "\n" +
@"        ""id"": ""{{wdInboundRuleID}}""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules"
  method := "POST"

  payload := strings.NewReader(`{
    "plan": {
        "id": "{{wdPlanID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
        "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
        "id": "{{wdInboundRuleID}}"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "plan": {
        "id": "{{wdPlanID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
        "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
        "id": "{{wdInboundRuleID}}"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"plan\": {\n        \"id\": \"{{wdPlanID}}\"\n    },\n    \"environment\": {\n        \"id\": \"{{envID}}\"\n    },\n    \"sourceStore\": {\n        \"id\": \"{{wdWritebackStoreID}}\"\n    },\n    \"targetStore\": {\n        \"id\": \"{{wdSourceStoreID}}\"\n    },\n    \"name\": \"Workday Use Case Writeback Rule\",\n    \"description\": \"Workday use case writeback rule description\",\n    \"parentRule\": {\n        \"id\": \"{{wdInboundRuleID}}\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "plan": {
      "id": "{{wdPlanID}}"
    },
    "environment": {
      "id": "{{envID}}"
    },
    "sourceStore": {
      "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
      "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
      "id": "{{wdInboundRuleID}}"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "plan": {
      "id": "{{wdPlanID}}"
    },
    "environment": {
      "id": "{{envID}}"
    },
    "sourceStore": {
      "id": "{{wdWritebackStoreID}}"
    },
    "targetStore": {
      "id": "{{wdSourceStoreID}}"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "parentRule": {
      "id": "{{wdInboundRuleID}}"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules"

payload = json.dumps({
  "plan": {
    "id": "{{wdPlanID}}"
  },
  "environment": {
    "id": "{{envID}}"
  },
  "sourceStore": {
    "id": "{{wdWritebackStoreID}}"
  },
  "targetStore": {
    "id": "{{wdSourceStoreID}}"
  },
  "name": "Workday Use Case Writeback Rule",
  "description": "Workday use case writeback rule description",
  "parentRule": {
    "id": "{{wdInboundRuleID}}"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "plan": {\n        "id": "{{wdPlanID}}"\n    },\n    "environment": {\n        "id": "{{envID}}"\n    },\n    "sourceStore": {\n        "id": "{{wdWritebackStoreID}}"\n    },\n    "targetStore": {\n        "id": "{{wdSourceStoreID}}"\n    },\n    "name": "Workday Use Case Writeback Rule",\n    "description": "Workday use case writeback rule description",\n    "parentRule": {\n        "id": "{{wdInboundRuleID}}"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "plan": {
    "id": "{{wdPlanID}}"
  },
  "environment": {
    "id": "{{envID}}"
  },
  "sourceStore": {
    "id": "{{wdWritebackStoreID}}"
  },
  "targetStore": {
    "id": "{{wdSourceStoreID}}"
  },
  "name": "Workday Use Case Writeback Rule",
  "description": "Workday use case writeback rule description",
  "parentRule": {
    "id": "{{wdInboundRuleID}}"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"plan\": {\n        \"id\": \"{{wdPlanID}}\"\n    },\n    \"environment\": {\n        \"id\": \"{{envID}}\"\n    },\n    \"sourceStore\": {\n        \"id\": \"{{wdWritebackStoreID}}\"\n    },\n    \"targetStore\": {\n        \"id\": \"{{wdSourceStoreID}}\"\n    },\n    \"name\": \"Workday Use Case Writeback Rule\",\n    \"description\": \"Workday use case writeback rule description\",\n    \"parentRule\": {\n        \"id\": \"{{wdInboundRuleID}}\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{wdPlanID}}/rules")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "id": "12e82a11-26d2-4ca6-b221-0b55fd1200ac",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2022-10-11T14:39:43.040Z",
    "updatedAt": "2022-10-11T14:39:43.040Z",
    "plan": {
        "id": "70a2dd92-da36-449b-bd70-6a5955af1364"
    },
    "sourceStore": {
        "id": "fdad63d8-591c-4cb2-a682-1ce6989ffd88"
    },
    "targetStore": {
        "id": "4e1b141b-ba0c-4922-a592-c86f2f802b35"
    },
    "name": "Workday Use Case Writeback Rule",
    "description": "Workday use case writeback rule description",
    "active": false,
    "deprovision": false,
    "parentRule": {
        "id": "a114cb98-ddd5-4d72-961c-632ef41dc35c"
    },
    "_links": {
        "create": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/plans/70a2dd92-da36-449b-bd70-6a5955af1364/rules"
        },
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        }
    }
}
```
